// ApogeeServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ApogeeServer.h"
#include "ApogeeServerDlg.h"
#include "Network.h"
#include "TCPIPServer.h"
#include "afxpriv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CApogeeServerDlg dialog

IMPLEMENT_DYNAMIC(CApogeeServerDlg, CDialog);

CApogeeServerDlg::CApogeeServerDlg(CApogee* aApogee,CWnd* pParent /*=NULL*/)
	: CDialog(CApogeeServerDlg::IDD, pParent)
{
	Apogee=aApogee;
	//{{AFX_DATA_INIT(CApogeeServerDlg)	
	m_Status = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
	Network=NULL;
	Apogee=NULL;
}

CApogeeServerDlg::~CApogeeServerDlg()
{
	if (Network) delete Network;
	Network=NULL;
}

BOOL CApogeeServerDlg::CanExit() {
	return true;
}
void CApogeeServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CApogeeServerDlg)
	DDX_Text(pDX, IDC_STATUS, m_Status);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CApogeeServerDlg, CDialog)
	//{{AFX_MSG_MAP(CApogeeServerDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_TEMP, OnTemp)
	ON_BN_CLICKED(IDC_EXPOSE, OnExpose)
	ON_BN_CLICKED(IDC_LED_DIALOG, OnLedDialog)
	ON_BN_CLICKED(IDC_IO_SETUP, OnIoSetup)
	ON_BN_CLICKED(IDC_DISCOVER, OnDiscover)
	ON_BN_CLICKED(IDC_TEST_TRIGGER_LINE, OnTestTriggerLine)
	ON_BN_CLICKED(IDC_EXPOSE_EXTERNAL, OnExposeExternal)
	ON_BN_CLICKED(IDC_DEBUG_START, OnDebugStart)
	ON_BN_CLICKED(IDC_DEBUG_STOP, OnDebugStop)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApogeeServerDlg message handlers

BOOL CApogeeServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CApogeeServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void CApogeeServerDlg::OnCancel() 
{
	WakeUp();
	if (CanExit())
		CDialog::OnCancel();
}

void CApogeeServerDlg::PumpMessages() {
	MSG msg;
	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) 
	{ 
		if ( !AfxGetApp ()->PumpMessage( ) ) 
		{ 	       
	       ::PostQuitMessage( 0); 
		    break; 
		} 
	} 
	// let MFC do its idle processing
	LONG lIdle = 0;
	while ( AfxGetApp()->OnIdle(lIdle++ ) )	;  
	// Perform some background processing here 
	// using another call to OnIdle	
}

void CApogeeServerDlg::OnTemp() 
{	
	WakeUp();
	Apogee->TemperatureDialog();
}

void CApogeeServerDlg::UpdateStatus(CString aStatus)
{
	m_Status=aStatus;
	UpdateData(FALSE);
}

void CApogeeServerDlg::OnExpose() 
{	
	WakeUp();
	Apogee->ResetSystem();
	Apogee->SetParameters(1,1,4,270,4,270,100,-20,false,0);
	const NrImages=1;
	unsigned short* Image[NrImages];	
	for (int i=0;i<NrImages;i++) Image[i]=new unsigned short[(1024*1024)/(1*1)];
	Apogee->TakePicture(NrImages,Image);	
	for (i=0;i<NrImages;i++) delete[] Image[i];
}

void CApogeeServerDlg::OnExposeExternal() 
{
	WakeUp();
	Apogee->ResetSystem();
	Apogee->SetParameters(1,1,0,256,0,256,100,-20,true,0);
	unsigned short* Image[1];	
	Image[0]=new unsigned short[512*512];	
	Apogee->TakePicture(1,Image);
	delete[] Image[0];
}

void CApogeeServerDlg::SetCamera(CApogee *aApogee)
{
	Apogee=aApogee;
}

void CApogeeServerDlg::OnLedDialog() 
{
	WakeUp();
	Apogee->LEDDialog();
}

void CApogeeServerDlg::OnIoSetup() 
{
	WakeUp();
	Apogee->IODialog();
}

void CApogeeServerDlg::OnDiscover() 
{
	WakeUp();
	Apogee->DiscoverCameraDialog();	
}

void CApogeeServerDlg::OnTestTriggerLine() 
{
	WakeUp();
	Apogee->TestTriggerLine();	
}



void CApogeeServerDlg::OnDebugStart() 
{
	WakeUp();
	 TCPIPServer->DebugStart();		 
	 TCPIPServer->UpdateStatus();
}

void CApogeeServerDlg::OnDebugStop() 
{
	WakeUp();
	TCPIPServer->DebugStop();	
	TCPIPServer->UpdateStatus();
}

void CApogeeServerDlg::SetTCPIPServer(CTCPIPServer *aTCPIPServer)
{
	TCPIPServer=aTCPIPServer;
}

 LRESULT CApogeeServerDlg::OnKickIdle(WPARAM, LPARAM lCount) {
	 AfxGetApp()->OnIdle(lCount);
	 return true;
}

void CApogeeServerDlg::WakeUp()
{
	((CApogeeServerApp*)AfxGetApp())->WakeUp();
}
